package ru.dima.weather.city;

import org.junit.jupiter.api.Test;
import ru.dima.weather.http.HttpRequester;
import ru.dima.weather.provider.MultiDaysWeatherInfo;
import ru.dima.weather.provider.OpenWeatherMapWeatherProvider;
import ru.dima.weather.provider.WeatherInfo;

import java.util.Random;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

public class OpenWeatherMapWeatherProviderTest {


    @Test
    void testGetName() {
        HttpRequester httpRequester = mock(HttpRequester.class);
        OpenWeatherMapWeatherProvider OpenWeatherMapWeatherProvider = new OpenWeatherMapWeatherProvider(httpRequester, "29ed5ca47c3d0c32385b18f1e82e522f");

        OpenWeatherMapWeatherProvider.getName();
        assertEquals("open-weather-map", OpenWeatherMapWeatherProvider.getName(), "open-weather-map");
    }
    @Test
    void testMultiDaysWeatherInfo_T() {
        HttpRequester httpRequester = mock(HttpRequester.class);
        String ft = "{ \"list\": [ " +
                "{ \"main\": { \"temp\": 15.0 } }, " +
                "{ \"main\": { \"temp\": 16.0 } }, " +
                "{ \"main\": { \"temp\": 17.0 } }, " +
                "{ \"main\": { \"temp\": 18.0 } }, " +
                "{ \"main\": { \"temp\": 19.0 } }, " +
                "{ \"main\": { \"temp\": 20.0 } }, " +
                "{ \"main\": { \"temp\": 21.0 } } " +
                "] }";
        when(httpRequester.getString(anyString())).thenReturn(ft);

        OpenWeatherMapWeatherProvider openWeatherMapWeatherProvider = new OpenWeatherMapWeatherProvider(httpRequester, "29ed5ca47c3d0c32385b18f1e82e522f");
        MultiDaysWeatherInfo weatherInfo = openWeatherMapWeatherProvider.getWeeklyWeatherInCity("Москва");
        assertEquals(7, weatherInfo.getPerDayWeather().size());
        assertEquals(15.0, weatherInfo.getPerDayWeather().get(0).temperature);
        assertEquals(16.0, weatherInfo.getPerDayWeather().get(1).temperature);
        assertEquals(17.0, weatherInfo.getPerDayWeather().get(2).temperature);
        assertEquals(18.0, weatherInfo.getPerDayWeather().get(3).temperature);
        assertEquals(19.0, weatherInfo.getPerDayWeather().get(4).temperature);
        assertEquals(20.0, weatherInfo.getPerDayWeather().get(5).temperature);
        assertEquals(21.0, weatherInfo.getPerDayWeather().get(6).temperature);

    }


}


